# 服务安装

## Windows服务安装（Windows操作系统）
    1. 创建应用程序，执行命令:  pyinstaller --onefile app.py
    2. 安装服务，在PowerShell中，执行命令：New-Service -Name MyService -BinaryPathName "E:\WorkSpace\SourceCode\WTOAAM\appService\dist\app.exe"
    另，在 PowerShell 窗口中，输入以下命令来停止并卸载指定的 Windows 服务
    Stop-Service -Name <ServiceName>  
    示例：
    Stop-Service -Name MyService
    
    进入注册表路径HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services 删除服务，重启计算机


   
## Deamon服务安装（Linux操作系统）
    1. 创建应用程序，执行命令:  pyinstaller --onefile app.py
    2. 编写 Systemd 服务单元文件：创建一个以 .service 为后缀的 Systemd 服务单元文件，该文件包含了关于你的服务的配置信息。通常这些文件存放在 /etc/systemd/system/ 目录下。例如，创建一个名为 mydaemon.service 的服务单元文件，内容类似于：
    [Unit]
    Description=My Daemon Service
    After=mydaemon.service

    [Service]
    Type=simple
    ExecStart=/path/to/your/daemon/app start
    ExecStop=/path/to/your/daemon/app stop
    Restart=always

    [Install]
    WantedBy=mydaemon.service

    其中：
    Description：描述服务的简短说明。
    After：指定服务应该在哪些其他服务之后启动。
    Type：指定服务的类型，可以是 simple、forking、oneshot、dbus 等。
    ExecStart：指定服务启动时执行的命令或可执行文件的路径。
    Restart：指定服务在失败或意外终止后是否应该自动重启。
    WantedBy：指定服务应该在何时启动。常见的是 multi-user.target，表示在系统引导时启动。

    3. 启用和启动服务：通过执行以下命令启用和启动服务：
    sudo systemctl enable mydaemon.service
    sudo systemctl start mydaemon.service

    4. 停止和重启服务：你可以使用 systemctl 命令停止和重启服务：
    sudo systemctl stop mydaemon.service   # 停止服务
    sudo systemctl restart mydaemon.service   # 重启服务

    5. 查看服务状态：你可以使用 systemctl status 命令来查看服务的状态和相关信息：
    systemctl status mydaemon.service

